#!/usr/bin/env python2.5
# Filename: berkinet.py

import indigo
import requests
from distutils.version import LooseVersion


########################################
def setLogLevel(self, pluginDisplayName, logLevel):
    if logLevel == "0":
        logLevel = 0
        debug = False
    elif logLevel == "1":
        logLevel = 1
        debug = False
    elif logLevel == "2":
        logLevel = 2
        debug = False
    elif logLevel == "3":
        logLevel = 3
        debug = True
    elif logLevel == "4":
        logLevel = 4
        debug = True
    else:
        logLevel = 1
        debug = False

    logLevelList = ['None', 'Normal', 'Verbose', 'Debug', 'Intense Debug']
    if logLevel > 0:
        indigo.server.log("Log level preferences are set to \"%s\"." % logLevelList[logLevel], type=pluginDisplayName)

    return (logLevel, debug)


########################################
def versionCheck(self, pluginDisplayName, logLevel, pluginId, pluginVersion):
    if logLevel > 1:
        self.debugLog(u"versionCheck() called")

    theUrl = 'https://api.indigodomo.com/api/v2/pluginstore/plugin-version-info.json?pluginId=' + pluginId
    myVersion = str(pluginVersion)
    #myVersion = '1.0.0'

    if logLevel > 2:
        indigo.server.log('url:%s' % theUrl, type=pluginDisplayName)

    try:
        r = requests.get(theUrl, timeout=10).json()
        latestVersion = r['plugins'][0]['latestRelease']['number']
        # self.errorLog(u'json dump1: %s\n' % latestVersion)

        if LooseVersion(myVersion) < LooseVersion(latestVersion):
            whatsNew = r['plugins'][0]['latestRelease']['whatsNew']
            self.errorLog(u"You are running vession %s. A newer version, %s, is available. Here's what is new:\n\t\t\t\t\t\t\t\t%s." % (myVersion, latestVersion, whatsNew))
        else:
            indigo.server.log(u'Your plugin version, %s, is current.' % myVersion, type=self.pluginDisplayName)

    except:
        self.errorLog(u"Unable to reach the version server.")
